var typecheck = require('./index');

typecheck({
    a: 4,
    b: 5,
    c: 'asdf',
    d: [1,2,3,4],
    e: {
        x: 12,
        f: 2
    }
}, {
    a: 'number',
    b: 'number',
    c: 'string',
    d: ['array', 'string'],
    e: {
        x: 'number'
    }
}, function (err, res) {
    if (!err) {
        console.log('failed to detect extra key');
    }
});

typecheck({
    a: 4,
    c: 'asdf',
    d: [1,2,3,4],
    e: {
        x: 12,
    }
}, {
    a: 'number',
    b: 'number',
    c: 'string',
    d: ['array', 'string'],
    e: {
        x: 'number'
    }
}, function (err, res) {
    if (!err) {
        console.log('failed to detect missing key');
    }
});

typecheck({
    a: 4,
    b: 2,
    c: 'asdf',
    d: 'whatever',
    e: {
        x: 12,
    }
}, {
    a: 'number',
    b: 'number',
    c: 'string',
    d: 'array,string',
    e: {
        x: 'number'
    }
}, function (err, res) {
    if (err) {
        console.log('failed to allow multiple allowed types');
    }
});

typecheck({
    a: 4,
    b: 2,
    c: [],
    d: 'whatever',
    e: {
        x: 12,
    }
}, {
    a: 'number',
    b: 'number',
    c: 'string',
    d: ['array', 'string'],
    e: {
        x: 'number'
    }
}, function (err, res) {
    if (!err) {
        console.log('failed to detect wrong type');
    }
});
